// cview.c for mmuview.x
// 4spaces/tab

#define __DOS_INLINE__
#include <sys/dos.h>
#include <stdio.h>

#ifdef __LF__		// sR[h̒`i_dos_print (); pj
#define CRLF "\n"
#else
#define CRLF "\r\n"
#endif

// MMU WX^Z[u
extern unsigned long  urp,srp,mmusr,dtt0,dtt1,itt0,itt1;
extern unsigned short tc;

#define LENGTH 256			// 󕶎܂
static char string[LENGTH];	// e|i[obt@

typedef unsigned long UL;	// AhXϊe[u֘Aϐ^

static struct {		// AhXϊ֘A
	int tia;
	int tib;
	int tic;
	void *p;
} tr[2];	// JnAhXƏIAhX𕪊đ


// tÕ}XNl
#define START_MASK	0x80
#define END_MASK	0x40
#define TIA_MASK	0x02
#define TIB_MASK	0x04
#define TIC_MASK	0x08


// AhXϊe[uǂݏo
extern UL getptr (const UL *);


static void tic (UL *t, int start, int end)
// TIC e[u\
{
int i;

	t += start;

	// e[uT[`
	for (i = start; i <= end; i++, t++) {
	UL v;
		// fBXNv^ǂݏo
		v = getptr (t);

		// ԐڃfBXNv^H
		if ((v & 3) == 2) {
		UL *p = (UL *)(v & 0xFFFFFFFC);	// y[WfBXNv^

			// ԐڃfBXNv^\
			snprintf (string, LENGTH, "%p: %08X TIC:%02X ADDR:%08X PDT:%X" CRLF,
				t, v, i, p, v & 3);
			_dos_print (string);

			// y[WfBXNv^ǂݏo
			v = getptr (p);

			// y[WfBXNv^\
			snprintf (string, LENGTH, "%p: %08X TIC:%02X ADDR:%08X "
				"UR:%X G:%X U1:%X U0:%X S:%X CM:%X M:%X U:%X W:%X PDT:%X" CRLF,
				p, v, i, v & 0xFFFFF000 << (tc >> 14 & 1),
				v >> 11 & (1 + (tc & 0x4000 ? 2 : 0)), v >> 10 & 1,
				v >> 9 & 1, v >> 8 & 1, v >> 7 & 1, v >> 5 & 3, v >> 4 & 1,
				v >> 3 & 1, v >> 2 & 1, v & 3);
			_dos_print (string);
		}

		else {
			// y[WfBXNv^\
			snprintf (string, LENGTH, "%p: %08X TIC:%02X ADDR:%08X "
				"UR:%X G:%X U1:%X U0:%X S:%X CM:%X M:%X U:%X W:%X PDT:%X" CRLF,
				t, v, i, v & 0xFFFFF000 << (tc >> 14 & 1),
				v >> 11 & (1 + (tc & 0x4000 ? 2 : 0)), v >> 10 & 1,
				v >> 9 & 1, v >> 8 & 1, v >> 7 & 1, v >> 5 & 3, v >> 4 & 1,
				v >> 3 & 1, v >> 2 & 1, v & 3);
			_dos_print (string);
		}
	}
}


static void tib (UL *t, int tia, int start, int end, unsigned char flag)
// TIB e[u\
{
int i;

	t += start;

	// e[uT[`
	for (i = start; i <= end; i++, t++) {
	UL v;
		// fBXNv^ǂݏo
		v = getptr (t);

		// \
		if (flag & TIB_MASK) {
			snprintf (string, LENGTH, "%p: %08X TIB:%02X ADDR:%08X U:%X W:%X UDT:%X" CRLF,
				t, v, i, v & 0xFFFFFF80 << !(tc >> 14 & 1), v >> 3 & 1, v >> 2 & 1, v & 3);
			_dos_print (string);
		}

		// ̒iΕ\
		if ((v & 2) && (flag & TIC_MASK)) {
		int s = 0, e = 0x3F >> (tc >> 14 & 1);
			if (tia == tr[0].tia && i == start) s =  tr[0].tic;
			if (tia == tr[1].tia && i == end) e = tr[1].tic;
			tic ((UL *)(v & 0xFFFFFF80 << !(tc & 0x4000)), s, e);
		}
	}
}


static void tia (UL *r, unsigned char flag)
// TIA e[u\
{
int i = tr[0].tia;

	r += i;

	// e[uT[`
	for (; i <= tr[1].tia; i++, r++) {
	UL v;
		// fBXNv^ǂݏo
		v = getptr (r);

		// \
		if (flag & TIA_MASK) {
			snprintf (string, LENGTH, "%p: %08X TIA:%02X ADDR:%08X U:%X W:%X UDT:%X" CRLF,
				r, v, i, v & 0xFFFFFE00, v >> 3 & 1, v >> 2 & 1, v & 3);
			_dos_print (string);
		}

		// ̒iΕ\
		if (v & 2) {
		int s, e;
			s = i == tr[0].tia ? tr[0].tib : 0;
			e = i == tr[1].tia ? tr[1].tib : 0x7F;
			tib ((UL *)(v & 0xFFFFFF00), i, s, e, flag);
		}
	}
}


int tview (void *start, void *end, unsigned char flag)
// fBXNv^\
{
int ssp;

	// 
	if (!(flag & START_MASK)) return 0;
	if (!(flag & END_MASK)) end = start;

	// fBXNv^\ł邩H
	if (!(tc >> 15)) {
		_dos_print ("ϊfBZ[u - fBXNv^͂܂" CRLF);
		return 0;
	}

	// start <= end ۏ؂
	if (start > end) {
	void *t = start;
		start = end;
		end = t;
	}

	// \ tr 𖄂߂
	{
	int p = tc >> 14 & 1;
		tr[0].tia = (UL)start >> 25;
		tr[0].tib = (UL)start >> 18 & 0x7F;
		tr[0].tic = (UL)start >> (12 + p) & 0x3F >> p;
		tr[0].p = start;
		tr[1].tia = (UL)end >> 25;
		tr[1].tib = (UL)end >> 18 & 0x7F;
		tr[1].tic = (UL)end >> (12 + p) & 0x3F >> p;
		tr[1].p = end;
	}

	// to supervisor
	ssp = _dos_super (0);

	// fBXNv^\
	tia ((UL *)urp, flag);

	// from supervisor
	if (ssp >= 0) _dos_super (ssp);

	return 0;
}


int rview (void)
// WX^l\
{
int ret = 0;	// ߂l
static struct {	// ߕϊWX^֘A
	const UL *const val;
	const char *const name;
} const ttr[4] = { &dtt0, "DTT0", &dtt1, "DTT1", &itt0, "ITT0", &itt1, "ITT1" };
int i;

	// URP
	snprintf (string, LENGTH, "URP:\t%08X" CRLF, urp);
	_dos_print (string);

	// SRP
	snprintf (string, LENGTH, "SRP:\t%08X" CRLF, srp);
	_dos_print (string);

	// MMUSR
	snprintf (string, LENGTH, "MMUSR:\t%08X  PA:%05X000 "
		"B:%X G:%X U1:%X U0:%X S:%X CM:%X M:%X W:%X T:%X R:%X" CRLF, mmusr, mmusr >> 12,
		mmusr >> 11 & 1, mmusr >> 10 & 1, mmusr >> 9 & 1, mmusr >> 8 & 1, mmusr >> 7 & 1,
		mmusr >> 5 & 3, mmusr >> 4 & 1, mmusr >> 2 & 1, mmusr >> 1 & 1, mmusr & 1);
	_dos_print (string);

	// [DI]TT[01]
	for (i = 0; i < 4; i++) {
	UL t = (UL)ttr[i].val;
		snprintf (string, LENGTH, "%s:\t%08X  BASE:%02X MASK:%02X "
			"E:%X S:%X U1:%X U0:%X CM:%X W:%X" CRLF, ttr[i].name, t, t >> 24, t >> 16 & 0xFF,
			t >> 15 & 1, t >> 13 & 3, t >> 9 & 1, t >> 8 & 1, t >> 5 & 3, t >> 2 & 1);
		_dos_print (string);
	}

	// TC
	snprintf (string, LENGTH, "TC:\t    %04X  E:%X P:%X" CRLF, tc, tc >> 15, tc >> 14 & 1);
	_dos_print (string);

	return ret;
}


// EOF
